GNU bug report logs - #46052
Colons fooling GNUmakefile mode

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: 積丹尼 Dan Jacobson <jidanni@HIDDEN>; Keywords: confirmed; merged with #17400, #33681, #33900, #35299, #36245, #37934, #45037, #46221, #48052; dated Sat, 23 Jan 2021 12:01:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Forcibly Merged 17400 33681 33900 35299 36245 37934 45037 46052 46221 48052. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Merged 17400 33681 33900 35299 36245 45037 46052 46221. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 46052 <at> debbugs.gnu.org:


Received: (at 46052) by debbugs.gnu.org; 23 Jan 2021 18:26:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 23 13:26:50 2021
Received: from localhost ([127.0.0.1]:35244 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l3NcY-0003h8-J7
	for submit <at> debbugs.gnu.org; Sat, 23 Jan 2021 13:26:50 -0500
Received: from eggs.gnu.org ([209.51.188.92]:52470)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1l3NcW-0003gw-BZ
 for 46052 <at> debbugs.gnu.org; Sat, 23 Jan 2021 13:26:48 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46081)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1l3NcR-0005ik-1i; Sat, 23 Jan 2021 13:26:43 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4496
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1l3NcB-0001Lr-00; Sat, 23 Jan 2021 13:26:42 -0500
Date: Sat, 23 Jan 2021 20:26:10 +0200
Message-Id: <83mtwz4iil.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: =?iso-8859-1?Q?K=E9vin?= Le Gouguec <kevin.legouguec@HIDDEN>
In-Reply-To: <87eeiblejv.fsf@HIDDEN> (message from =?iso-8859-1?Q?K=E9v?=
 =?iso-8859-1?Q?in?= Le Gouguec on Sat, 23 Jan 2021 18:59:48 +0100)
Subject: Re: bug#46052: Colons fooling GNUmakefile mode
References: <87tur914qj.5.fsf@HIDDEN> <87v9bnlq6x.fsf@HIDDEN>
 <83sg6r4uu1.fsf@HIDDEN> <87im7nlmx9.fsf@HIDDEN>
 <83r1mb4ler.fsf@HIDDEN> <87eeiblejv.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 46052
Cc: 46052 <at> debbugs.gnu.org, jidanni@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Kvin Le Gouguec <kevin.legouguec@HIDDEN>
> Cc: jidanni@HIDDEN,  46052 <at> debbugs.gnu.org
> Date: Sat, 23 Jan 2021 18:59:48 +0100
> 
> >   foo \
> > 	  bar: baz
> 
> Thanks!  I suspected there could be cases I hadn't thought of; sorry to
> have misunderstood your point.
> 
> FWIW, right now make-mode seems to fail to fontify your example
> correctly, ironically: I'm not seeing any face applied to the target
> ("foo \\\n\tbar").

I wrote that to prevent people from installing a too-simplistic
solution.  I had no idea whether this is correctly supported
currently.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46052; Package emacs. Full text available.

Message received at 46052 <at> debbugs.gnu.org:


Received: (at 46052) by debbugs.gnu.org; 23 Jan 2021 17:59:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 23 12:59:58 2021
Received: from localhost ([127.0.0.1]:35216 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l3NCY-000332-9b
	for submit <at> debbugs.gnu.org; Sat, 23 Jan 2021 12:59:58 -0500
Received: from mail-wr1-f43.google.com ([209.85.221.43]:35958)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kevin.legouguec@HIDDEN>) id 1l3NCW-00032o-AB
 for 46052 <at> debbugs.gnu.org; Sat, 23 Jan 2021 12:59:56 -0500
Received: by mail-wr1-f43.google.com with SMTP id 6so8194235wri.3
 for <46052 <at> debbugs.gnu.org>; Sat, 23 Jan 2021 09:59:56 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=Pahik77cpGKf8oAKhnMcMm0nLNJuiv5iIt8MJbwkwkg=;
 b=F/xvu0TsfRPTuLwhkgB9ow1ZZ7CrBM6Uap8SoBRZR5raZOE7r+T4lOVEkKn2htwWPr
 9mFvz40uav7tNICgzvqMK8ncFPnwkA+oW0SCyTAlQz3STc8OMJDNYm66TnxblbA/9A/X
 gPu0bVw4H+KWhYa0fPLSu3bp8mwK0zn6tLnh0ZbA/+Jo5wkq0yNRxGTEEi8+6y8MRqSY
 2JZN0xFY+lYv8N6M797lewTE8bne+IgJYo/zq9tMjqK2MjiPDgdQxDmWKz1ita+hjj/O
 RO9MH45W09l+OjV7dHNY+1xscECZMR0KHpMir73KIlWSBD80sZH1OFYLIAzS81DlzP9W
 y6Og==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=Pahik77cpGKf8oAKhnMcMm0nLNJuiv5iIt8MJbwkwkg=;
 b=III0GwE16sgY5W73HKlv34j+HtyUdxAaU3cGFmmtYH86cuJyuzJ7iUF/o6d/NBPBa2
 QXbViqemgkLgUXfPF5ectoQI5FzCjbcW59L5nAgcekOvFTObkgYruJv+95YwK2jAUtBp
 mmEG2UNMNKGVqGHpb+Lw0FsL0WcSabt7tj0UX8MCwDlfxFX0kf+AnGmVf3bWS8tGEjdK
 J0WWTy7KXx9wLvMjeg1ALYlfJymR0twO4lGarNgMCa+k9kT7aYZnDakqSmsRt6ib2sme
 9TrMZl6w+9pLWvG3ZSKfc9tplFksBfMR6Jj/6i+mB+m+B178MvvEfJ5UwYpq5ZhHWbgX
 b3Dg==
X-Gm-Message-State: AOAM531x0QPYyyeFIG2Xp60XwITWE3wP/3uPS0Pm3rxlbxVShNH7FS6Y
 w4S+KrYSvRd/qO6n/hQ0y6gMqG2BJOwQ0A==
X-Google-Smtp-Source: ABdhPJyGu6+jizsEv2XIIvcI55nP7LKU6il4uGWpn9BszKqsdYQT5vu5tM6xtGpv/AM4nrPSaKnQ+g==
X-Received: by 2002:a05:6000:1788:: with SMTP id
 e8mr9985271wrg.171.1611424790015; 
 Sat, 23 Jan 2021 09:59:50 -0800 (PST)
Received: from my-little-tumbleweed ([2a01:e0a:20e:d340:922b:34ff:fe95:9aed])
 by smtp.gmail.com with ESMTPSA id
 v22sm14879987wml.2.2021.01.23.09.59.48
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 23 Jan 2021 09:59:49 -0800 (PST)
From: =?utf-8?Q?K=C3=A9vin_Le_Gouguec?= <kevin.legouguec@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#46052: Colons fooling GNUmakefile mode
References: <87tur914qj.5.fsf@HIDDEN> <87v9bnlq6x.fsf@HIDDEN>
 <83sg6r4uu1.fsf@HIDDEN> <87im7nlmx9.fsf@HIDDEN>
 <83r1mb4ler.fsf@HIDDEN>
Date: Sat, 23 Jan 2021 18:59:48 +0100
In-Reply-To: <83r1mb4ler.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 23 Jan
 2021 19:23:40 +0200")
Message-ID: <87eeiblejv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46052
Cc: 46052 <at> debbugs.gnu.org, jidanni@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> I didn't say a _rule_ can start with a TAB, I said a rule's _line_
> could start with a TAB.  For example (indentation added for
> readability):
>
>   foo \
> 	  bar: baz

Thanks!  I suspected there could be cases I hadn't thought of; sorry to
have misunderstood your point.

FWIW, right now make-mode seems to fail to fontify your example
correctly, ironically: I'm not seeing any face applied to the target
("foo \\\n\tbar").




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46052; Package emacs. Full text available.

Message received at 46052 <at> debbugs.gnu.org:


Received: (at 46052) by debbugs.gnu.org; 23 Jan 2021 17:23:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 23 12:23:49 2021
Received: from localhost ([127.0.0.1]:35161 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l3MdZ-00028e-CC
	for submit <at> debbugs.gnu.org; Sat, 23 Jan 2021 12:23:49 -0500
Received: from eggs.gnu.org ([209.51.188.92]:41430)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1l3MdX-00028E-EV
 for 46052 <at> debbugs.gnu.org; Sat, 23 Jan 2021 12:23:47 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45016)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1l3MdS-0006rx-5I; Sat, 23 Jan 2021 12:23:42 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4662
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1l3MdR-0006lZ-3T; Sat, 23 Jan 2021 12:23:41 -0500
Date: Sat, 23 Jan 2021 19:23:40 +0200
Message-Id: <83r1mb4ler.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: =?iso-8859-1?Q?K=E9vin?= Le Gouguec <kevin.legouguec@HIDDEN>
In-Reply-To: <87im7nlmx9.fsf@HIDDEN> (message from =?iso-8859-1?Q?K=E9v?=
 =?iso-8859-1?Q?in?= Le Gouguec on Sat, 23 Jan 2021 15:58:58 +0100)
Subject: Re: bug#46052: Colons fooling GNUmakefile mode
References: <87tur914qj.5.fsf@HIDDEN> <87v9bnlq6x.fsf@HIDDEN>
 <83sg6r4uu1.fsf@HIDDEN> <87im7nlmx9.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 46052
Cc: 46052 <at> debbugs.gnu.org, jidanni@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Kvin Le Gouguec <kevin.legouguec@HIDDEN>
> Cc: jidanni@HIDDEN,  46052 <at> debbugs.gnu.org
> Date: Sat, 23 Jan 2021 15:58:58 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > I'm not sure a target line cannot possibly start with a TAB.
> 
> I'll admit to not being an expert in makefile syntax; I do find this
> entry in (info "(make) Error Messages") encouraging though:
> 
> > 'recipe commences before first target. Stop.'
> > 'missing rule before recipe. Stop.'
> >      This means the first thing in the makefile seems to be part of a
> >      recipe: it begins with a recipe prefix character and doesn't appear
> >      to be a legal 'make' directive (such as a variable assignment).
> >      Recipes must always be associated with a target.
> 
> While that phrasing doesn't rule out subsequent targets from starting
> with a TAB, empirically that seems to be the case:

I didn't say a _rule_ can start with a TAB, I said a rule's _line_
could start with a TAB.  For example (indentation added for
readability):

  foo \
	  bar: baz





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46052; Package emacs. Full text available.

Message received at 46052 <at> debbugs.gnu.org:


Received: (at 46052) by debbugs.gnu.org; 23 Jan 2021 14:59:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 23 09:59:08 2021
Received: from localhost ([127.0.0.1]:34895 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l3KNX-0006sx-Pp
	for submit <at> debbugs.gnu.org; Sat, 23 Jan 2021 09:59:08 -0500
Received: from mail-wm1-f53.google.com ([209.85.128.53]:34018)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kevin.legouguec@HIDDEN>) id 1l3KNV-0006sS-LO
 for 46052 <at> debbugs.gnu.org; Sat, 23 Jan 2021 09:59:06 -0500
Received: by mail-wm1-f53.google.com with SMTP id o10so8132964wmc.1
 for <46052 <at> debbugs.gnu.org>; Sat, 23 Jan 2021 06:59:05 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=nFoxEniM4fcS6CiSyypcjifPvVaGQCISITTqIqiShXQ=;
 b=M0Rc7lhWTlCdzk3n+N4TZmYwxS0GCM0g0zlKCtoehPWXnf/cUls/fcXQcK44+8CShO
 iM6CtfwyjB0sClKCtUCm67NLm3pHbqgD5zBFQnV3W0LAi7qJdyazXxe4buMraMZ3QLQB
 2Sa5VHaZkTJgQsrN6NScNeZ1xLKxjDT5IZL3SH8Dex4nW8QS4jz9UU0SK+8r+8Yf/4of
 x4udfOYbqkjwGcEvcQQD46P31ICNv5u2vbJ14h5gaYlDhAyVRsnRLx2XFpKNFGvMAr57
 Tfm8jDVxyLvvNONrqrvwdYJkGR8tNMDdwJXYfbmP3JZd3B9AUOWkZWkv7n1hDki6TvbD
 nRzg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=nFoxEniM4fcS6CiSyypcjifPvVaGQCISITTqIqiShXQ=;
 b=aihbOYhwaz2jrTZy8tXyiXnGGovRIZ5TOYShd99pgjbKkqIVfKX5FMBbHpzv65LL7H
 9iJSTUUzrO5a5kJ1CP/ZXoEvf+Niden0E+4BIaltBPx88zpoB7SW2GCZc5ZbhKU1k2dJ
 v1/FM4YdnEIQUnNxqZHsTPoaVYww3PySRU/JuDJw0PotQ1KUMdgMpSA6zvMcPYOhLzsh
 oNZP3a6Oo1C5ALazTvXK73DryJACBsuuIfqURm7woW+qhbZXHaBxKpZZ/hROQXxFOL5w
 gvDlxFm0FYSWw53bk1qVpIADBqRN3Zg+CoJKqxA5tJa9U475b0r02Kgqjg85hdmabrzv
 Qm6Q==
X-Gm-Message-State: AOAM532uMvs+Hu6aqaGFE6hzmGwiUMi/LgjgaM1QKNYh9E/T16Zsc+by
 +umx6tSmhZeKGtxqJEnKgwpUVErl5UsUcw==
X-Google-Smtp-Source: ABdhPJxyt6LMFQah8CjHytbLzKts8q/l4dUfoFeGJpzHQfY/GCNhblfDhYbjljwWVeWkK+msAietMw==
X-Received: by 2002:a1c:b1d7:: with SMTP id a206mr8460507wmf.88.1611413939403; 
 Sat, 23 Jan 2021 06:58:59 -0800 (PST)
Received: from my-little-tumbleweed ([2a01:e0a:20e:d340:922b:34ff:fe95:9aed])
 by smtp.gmail.com with ESMTPSA id
 a130sm14730188wmf.4.2021.01.23.06.58.58
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 23 Jan 2021 06:58:58 -0800 (PST)
From: =?utf-8?Q?K=C3=A9vin_Le_Gouguec?= <kevin.legouguec@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#46052: Colons fooling GNUmakefile mode
References: <87tur914qj.5.fsf@HIDDEN> <87v9bnlq6x.fsf@HIDDEN>
 <83sg6r4uu1.fsf@HIDDEN>
Date: Sat, 23 Jan 2021 15:58:58 +0100
In-Reply-To: <83sg6r4uu1.fsf@HIDDEN> (Eli Zaretskii's message of "Sat, 23 Jan
 2021 16:00:06 +0200")
Message-ID: <87im7nlmx9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46052
Cc: 46052 <at> debbugs.gnu.org, jidanni@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> I'm not sure a target line cannot possibly start with a TAB.

I'll admit to not being an expert in makefile syntax; I do find this
entry in (info "(make) Error Messages") encouraging though:

> 'recipe commences before first target. Stop.'
> 'missing rule before recipe. Stop.'
>      This means the first thing in the makefile seems to be part of a
>      recipe: it begins with a recipe prefix character and doesn't appear
>      to be a legal 'make' directive (such as a variable assignment).
>      Recipes must always be associated with a target.

While that phrasing doesn't rule out subsequent targets from starting
with a TAB, empirically that seems to be the case:

#+begin_src makefile
foo:
	echo foo

	bar:
	echo bar
#+end_src

$ make
echo foo
foo
bar:
make: bar:: No such file or directory
make: *** [makefile:3: foo] Error 127

#+begin_src makefile
foo:
	echo foo

QUUX = CORGE

	bar:
	echo bar
#+end_src

$ make
makefile:6: *** recipe commences before first target.  Stop.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46052; Package emacs. Full text available.

Message received at 46052 <at> debbugs.gnu.org:


Received: (at 46052) by debbugs.gnu.org; 23 Jan 2021 14:00:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 23 09:00:13 2021
Received: from localhost ([127.0.0.1]:33879 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l3JSX-0005E6-7w
	for submit <at> debbugs.gnu.org; Sat, 23 Jan 2021 09:00:13 -0500
Received: from eggs.gnu.org ([209.51.188.92]:33980)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1l3JSV-0005DO-RL
 for 46052 <at> debbugs.gnu.org; Sat, 23 Jan 2021 09:00:12 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:40647)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>)
 id 1l3JSQ-0007UD-5O; Sat, 23 Jan 2021 09:00:06 -0500
Received: from 84.94.185.95.cable.012.net.il ([84.94.185.95]:4168
 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1l3JSO-0002dz-Tm; Sat, 23 Jan 2021 09:00:05 -0500
Date: Sat, 23 Jan 2021 16:00:06 +0200
Message-Id: <83sg6r4uu1.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: =?utf-8?Q?K=C3=A9vin?= Le Gouguec <kevin.legouguec@HIDDEN>
In-Reply-To: <87v9bnlq6x.fsf@HIDDEN> (message from =?utf-8?Q?K=C3=A9vin?=
 Le Gouguec on Sat, 23 Jan 2021 14:48:22 +0100)
Subject: Re: bug#46052: Colons fooling GNUmakefile mode
References: <87tur914qj.5.fsf@HIDDEN> <87v9bnlq6x.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 46052
Cc: 46052 <at> debbugs.gnu.org, jidanni@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Kévin Le Gouguec <kevin.legouguec@HIDDEN>
> Date: Sat, 23 Jan 2021 14:48:22 +0100
> Cc: 46052 <at> debbugs.gnu.org
> 
> It sure would be nice if make-mode could check whether a line starts
> with a tab before slapping the makefile-targets face on it.

I'm not sure a target line cannot possibly start with a TAB.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46052; Package emacs. Full text available.

Message received at 46052 <at> debbugs.gnu.org:


Received: (at 46052) by debbugs.gnu.org; 23 Jan 2021 13:48:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 23 08:48:33 2021
Received: from localhost ([127.0.0.1]:33873 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l3JHF-0004uF-3u
	for submit <at> debbugs.gnu.org; Sat, 23 Jan 2021 08:48:33 -0500
Received: from mail-wm1-f48.google.com ([209.85.128.48]:52676)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kevin.legouguec@HIDDEN>) id 1l3JHD-0004tz-26
 for 46052 <at> debbugs.gnu.org; Sat, 23 Jan 2021 08:48:32 -0500
Received: by mail-wm1-f48.google.com with SMTP id m187so6651529wme.2
 for <46052 <at> debbugs.gnu.org>; Sat, 23 Jan 2021 05:48:30 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version:content-transfer-encoding;
 bh=jh2d1/1fNcco+oqrHGBYbmHFFhVJgB0TBBvp8nVxg1g=;
 b=NhOfAXOn5WfZuXK4s7mcLYJ0lhirRPHH0i7JmGE/nRXI31s5solq5YyytReabok6nf
 GJeWtE3A00RtxbJuHmDZW0v6fsi7yJk0415/NQnkzgXo0CrNQ0krlWEEYSZjCEoZnH4D
 0NLe4wPPMhqXKaTsaEizO3U0D7QIy225zSystE5TIOv65x72u3Q+w/dCVB8+Q7gV3trp
 4xm9b85JSPr+nPT9Bt9vZ0Ji2GgZnfiPvfOb2LFd0zddUSeK9ypRtyu/6Fs9+7bj/R7Q
 f8d1qpA2cBbFlJDpMWlapzT9L0PntkkM6COJaTb98muf2NDl3IzVDqTtMxkbLhLqpmMK
 L8vw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version:content-transfer-encoding;
 bh=jh2d1/1fNcco+oqrHGBYbmHFFhVJgB0TBBvp8nVxg1g=;
 b=QCpPFyFc7LJH3imNGZJQpPvo7AxMtZ2vZ1j8W3Td83ug4W8dvW4bXfjxV13gZ82vKw
 FURgBJFqpG3qlO5KvexoydacfKL6QuLbScxXxw4J+x6gN09JKar3dlARYsFJEwOPkAEl
 Zye65zpPjAfkzm8QdtRGwXj/fglp6AAsVzBPjseDHkbEb3CfHlenv7FXiZbL5v14IazB
 LrDunG8Gce3sKRjKLxnZGNNr05co+ugWN8SnR0G96cmHNCSVOmUlq0fJPUZVNsJA3aRa
 g68CPvvBsX2JQqCvfS1d6Wg6XxLlwC7SzMMSd5vtdBL8fd4lSV2QgtIGF51me0SfMnSW
 GfZw==
X-Gm-Message-State: AOAM532nMtJ0QW2pmQjtzpMe5rnjJlewGofa8j+2ZLeuwQx62KIconjE
 nYATKGSY62/69X/PSzTJcQxuQYLPptYaXw==
X-Google-Smtp-Source: ABdhPJx+HQVQL+IrGxTH/HnYRRgbZEkNPermJ0JZACY0tmPRM3Z6eHk/bFEqcIO1chNKtGqvjc87yQ==
X-Received: by 2002:a1c:8095:: with SMTP id b143mr8151924wmd.71.1611409704743; 
 Sat, 23 Jan 2021 05:48:24 -0800 (PST)
Received: from my-little-tumbleweed ([2a01:e0a:20e:d340:922b:34ff:fe95:9aed])
 by smtp.gmail.com with ESMTPSA id
 u3sm17970073wre.54.2021.01.23.05.48.23
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sat, 23 Jan 2021 05:48:23 -0800 (PST)
From: =?utf-8?Q?K=C3=A9vin_Le_Gouguec?= <kevin.legouguec@HIDDEN>
To: =?utf-8?B?56mN5Li55bC8?= Dan Jacobson <jidanni@HIDDEN>
Subject: Re: bug#46052: Colons fooling GNUmakefile mode
References: <87tur914qj.5.fsf@HIDDEN>
Date: Sat, 23 Jan 2021 14:48:22 +0100
In-Reply-To: <87tur914qj.5.fsf@HIDDEN> (=?utf-8?B?IuepjeS4ueWwvA==?=
 Dan Jacobson"'s message of "Fri, 22 Jan 2021 21:27:32 +0800")
Message-ID: <87v9bnlq6x.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 46052
Cc: 46052 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

=E7=A9=8D=E4=B8=B9=E5=B0=BC Dan Jacobson <jidanni@HIDDEN> writes:

> Perhaps already fixed.

AFAICT this is still reproducible in master (c83590b).

Out of curiosity, I took a look at make-mode.el, thinking it might just
be a matter of adding a [^\t] in a regexp somewhere after a ^ anchor,
but I'm not used to debugging font-lock setups and I don't really know
which occurrence of makefile-targets is responsible for this spurious
fontification (maybe the one paired with makefile-match-dependency,
which relies on makefile-dependency-regex?).

It sure would be nice if make-mode could check whether a line starts
with a tab before slapping the makefile-targets face on it.

(Supporting .RECIPEPREFIX would also be neat I guess, though the fact
that this variable can be set multiple times in a single makefile will
probably pose an interesting challenge.)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#46052; Package emacs. Full text available.
Forcibly Merged 17400 33681 33900 35299 36245 45037 46052. Request was from Glenn Morris <rgm@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 23 Jan 2021 12:00:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 23 07:00:48 2021
Received: from localhost ([127.0.0.1]:33785 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1l3Hay-0006VX-9H
	for submit <at> debbugs.gnu.org; Sat, 23 Jan 2021 07:00:48 -0500
Received: from lists.gnu.org ([209.51.188.17]:42740)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <jidanni@HIDDEN>) id 1l3Haw-0006VO-MR
 for submit <at> debbugs.gnu.org; Sat, 23 Jan 2021 07:00:46 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:35590)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <jidanni@HIDDEN>)
 id 1l3Hau-0008MR-SK
 for bug-gnu-emacs@HIDDEN; Sat, 23 Jan 2021 07:00:46 -0500
Received: from donkey.elm.relay.mailchannels.net ([23.83.212.49]:6000)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <jidanni@HIDDEN>)
 id 1l3Haq-00057b-OW
 for bug-gnu-emacs@HIDDEN; Sat, 23 Jan 2021 07:00:43 -0500
X-Sender-Id: dreamhost|x-authsender|jidanni@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id D9545102683
 for <bug-gnu-emacs@HIDDEN>; Sat, 23 Jan 2021 12:00:36 +0000 (UTC)
Received: from pdx1-sub0-mail-a9.g.dreamhost.com
 (100-105-161-48.trex.outbound.svc.cluster.local [100.105.161.48])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 6C4EE102588
 for <bug-gnu-emacs@HIDDEN>; Sat, 23 Jan 2021 12:00:36 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jidanni@HIDDEN
Received: from pdx1-sub0-mail-a9.g.dreamhost.com (pop.dreamhost.com
 [64.90.62.162])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384)
 by 100.105.161.48 (trex/6.0.2); Sat, 23 Jan 2021 12:00:36 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jidanni@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Vacuous-Eight: 361645e4146a0a89_1611403236697_1573771922
X-MC-Loop-Signature: 1611403236696:1317489288
X-MC-Ingress-Time: 1611403236696
Received: from pdx1-sub0-mail-a9.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a9.g.dreamhost.com (Postfix) with ESMTP id 0086B7EFAE
 for <bug-gnu-emacs@HIDDEN>; Sat, 23 Jan 2021 04:00:35 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=jidanni.org; h=from:to
 :subject:date:message-id:mime-version:content-type; s=
 jidanni.org; bh=/vx1Gqs0dk1fqWWJnVSn3N7AQrg=; b=RJOBnKZTjJdoQAec
 k2xT2mrEmv+TtHHyZO5GNgKX5wsf/SGx3rrKNFZcRWAA55PNF9INk4gd39UD4w9R
 yHaWIREeAtjQe7qqIPFITu8KefJh0GM/J8v717F14VbGsTifZErjC0Ljbj9Pv+Ld
 3pAcX6ZBF1ldbRRnS8sD8dIXcUE=
Received: from jidanni.org (1-170-82-17.dynamic-ip.hinet.net [1.170.82.17])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jidanni@HIDDEN)
 by pdx1-sub0-mail-a9.g.dreamhost.com (Postfix) with ESMTPSA id A4E607EFAA
 for <bug-gnu-emacs@HIDDEN>; Sat, 23 Jan 2021 04:00:35 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a9
From: =?utf-8?B?56mN5Li55bC8?= Dan Jacobson <jidanni@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: Colons fooling GNUmakefile mode
Date: Fri, 22 Jan 2021 21:27:32 +0800
Message-ID: <87tur914qj.5.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: pass client-ip=23.83.212.49; envelope-from=jidanni@HIDDEN;
 helo=donkey.elm.relay.mailchannels.net
X-Spam_score_int: -9
X-Spam_score: -1.0
X-Spam_bar: -
X-Spam_report: (-1.0 / 5.0 requ) BAYES_00=-1.9, DATE_IN_PAST_12_24=1.049,
 DKIM_SIGNED=0.1, DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1,
 RCVD_IN_DNSWL_NONE=-0.0001, RCVD_IN_MSPIKE_H4=0.001, RCVD_IN_MSPIKE_WL=0.001,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -0.6 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.6 (-)

Colons on lines 2 and 4 shouldn't change the line color:
$ cat Makefile
eee:
	set -x; $c 11999 3555; $c 11999 3355; :
	set -x; $c 9999   999; $c 9999   799;
	set -x; $c 8499  1606; $c 8499   599; :

emacs-version "27.1".
Perhaps already fixed.




Acknowledgement sent to 積丹尼 Dan Jacobson <jidanni@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#46052; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 27 Apr 2021 00:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.